#include "common.h"
#include <syslog.h>

int
main(int argc, char **argv)
{
  uid_t                    uid;
  int                      nLoginRecs;
  LoginRec                 loginRec[MAX_USERS];
  UserRec                  ur;
  char                     login[MAX_LOGINCHARS + 1];
  char   hostname[256];
  word   myHostAddr;
  int    hostIdx;

  // Guess!
  readConfig();

  // figure out who to logout
  userList(&nLoginRecs, loginRec);

  if (argc != 2) {
    printf("Usage: acua_radlogout username\n");
    openlog("acua_radlogout", LOG_PID, LOG_AUTHPRIV);
    syslog(LOG_ERR, "Incorrect usage of acua_radlogout. Usage: acua_radlogout username");
    closelog();
    return(1);
  }

  // If the username was supplied on the command line as argv[1]
  // it will execute this bit..
  uid = UIDfromLogin(argv[1]);
  // deal with it if it's not a real login
  if (uid == (uid_t)-1) {
                          printf("user not found (/etc/passwd): %s\n", argv[1]);
                          return(1);
  }

  if (!loginFromUID(login, uid)) {
    printf("Could not resolve UID to username.\n");
    return(1);
  }

  // mark them as logged out
  userFileOpen();
  if (userFileSearch(&ur, uid)) {
    printf("user not found: %s\n", login);
    goto fail;
  }

  gethostname(hostname, 256);
  myHostAddr = hostAddr(hostname);

  hostIdx = findHost(&ur, myHostAddr);
  if (hostIdx < 0) {
    printf("user not logged into this host: %s\n", login);
    goto fail;
  }
  
  // record the amount of input/output bytes (according to radius)
  //if (argc==4) {  ur.bTx += atoi(argv[2]);
  //                ur.bRx += atoi(argv[3]);
  //}

  removeHost(&ur, myHostAddr);
  userFileEdit(&ur);
  userFileClose();
  printf("user logged out: %s\n", login);
  return(0);
  
fail:
  userFileClose();
  return(0);
}
